//
//	"$Id: CoolInputBrowser.h The Dec 27 2006 Dmitry Perov  $"
//
//	CoolInputBrowser for the Fast Light Tool Kit (FLTK2).
//
//   Copyright 1998-2006 by Bill Spitzak and others.
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the
//   Free Software Foundation, Inc.,
//   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//	Please report all bugs and problems to "gentooshnik@rambler.ru"
//



#ifndef fltk_CoolInputBrowser_h
#define fltk_CoolInputBrowser_h

#include <fltk/InputBrowserTmp.h>
#include <fltk/Cursor.h>
#include <fltk/Font.h>
#include <fltk/Color.h>

namespace fltk {

class FL_API CoolInputBrowser : public InputBrowserTmp {

public:

/** lang for popup menu with click right button mouse */
enum {
LANG_EN = 0,
LANG_RU = 1
};

  CoolInputBrowser(int,int,int,int,const char * = 0, int lang = LANG_EN);
  ~CoolInputBrowser();

/** without author style popup menu */
void style_fltk(bool s){ if(s){ style_off = true; } else { style_off = false; } }
bool style_fltk(){ if(style_off){ return false; } else { return true; } }

/** style popup menu with click right button mouse */
void set_color_popup(const Color c);
void set_text_color_popup(const Color c);
void set_selection_color_popup(const Color c);
void set_selection_textcolor_popup(const Color c);
void set_textsize_popup(const int sz);
void set_font_popup(Font *f);
void set_box_style_popup(Box *b);
void set_lang_popup(const int lng);
int lang_popup() const;

void _paste(int, Input* c);
int handle(int);

Cursor* cursor;
Color color_popup;
Color text_color_popup;
Color selection_color_popup;
Color selection_textcolor_popup;
int textsize_popup;
Font *font_popup;

private:

void init_style();
int _Lang;
bool style_off;

};

}

#endif

//
// End of  "$Id: CoolInputBrowser.h The Dec 27 2006 Dmitry Perov  $" .
//
