//
//	"$Id: Conteiner.cxx The Dec 18 2006 Dmitry Perov  $"
//
//	Conteiner for the Fast Light Tool Kit (FLTK2).
//
//   Copyright 1998-2006 by Bill Spitzak and others.
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the
//   Free Software Foundation, Inc.,
//   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//	Please report all bugs and problems to "gentooshnik@rambler.ru"
//

#ifndef Conteiner_cxx
#define Conteiner_cxx 1

#include <fltk/Conteiner.h>
#include <fltk/utf.h>

using namespace std;

class IntToChar{

public:
IntToChar(){ }
~IntToChar(){ delete s; }

const char* Convert(const int num){
i = 0; s= new char[64];
itoa(num);
s[i] = '\0';

return s; }

private:
void itoa(int n){

if(n){
itoa(n/10);
s[i]=(n%10+'0');
i++; } }

protected:
char *s;
int i;

};

Conteiner::Conteiner(){

conteiner = new StringMap;
double_v = false;
_size = 1024;
_position = 0;

}

Conteiner::~Conteiner(){ delete conteiner; }

template<typename T> bool Conteiner::FromString(const std::string& from, T& to){
std::istringstream iss(from);
return iss >> to; }


std::string Conteiner::element(const int index){

if(!isIndex(index)){ return false; }

StringMap::iterator ptr;

for(ptr = conteiner->begin(); ptr != conteiner->end(); ++ptr){

if(ptr->first == index){ return ptr->second; }

}

}

bool Conteiner::isIndex(const int index){

if(index < 0 || index > (count()-1)){ return false; }

return true;

}

const int Conteiner::utf8len(const char* src){

const int len = utf8test(src, strlen(src));
const int len_std = strlen(src);

if(len == 0 && len_std >= 0){ return len_std; }
else{ return len; }

}

void Conteiner::insert(const char* data){

if(!double_v){ if(isExists(data)){ return; } }

StringMap::iterator iter;
const int sz = count();

conteiner->insert(make_pair(sz, ""));

iter = conteiner->begin();
advance(iter, sz);

iter->second.reserve(_size);
iter->second.append(data);

}

void Conteiner::insert(const char data){

if(!double_v){ if(isExists(data)){ return; } }

char t[8];
sprintf(t, "%c", data);

StringMap::iterator iter;
const int sz = count();

conteiner->insert(make_pair(sz, ""));

iter = conteiner->begin();
advance(iter, sz);

iter->second.reserve(_size);
iter->second.append(t);

}


void Conteiner::insert(const int data){

if(!double_v){ if(isExists(data)){ return; } }

char t[64];
sprintf(t, "%d", data);

StringMap::iterator iter;
const int sz = count();

conteiner->insert(make_pair(sz, ""));

iter = conteiner->begin();
advance(iter, sz);

iter->second.reserve(_size);
iter->second.append(t);

}

void Conteiner::insert(const std::string data){

if(!double_v){ if(isExists(data)){ return; } }

StringMap::iterator iter;
const int sz = count();

conteiner->insert(make_pair(sz, ""));

iter = conteiner->begin();
advance(iter, sz);

iter->second.reserve(_size);
iter->second.append(data.data());

}


const char* Conteiner::value(const int index){

if(!isIndex(index)){ return (char*)""; }

StringMap::iterator iter;

iter = conteiner->begin();
advance(iter, index);
return iter->second.data();

}


const char* Conteiner::value(){

if(count() == 0){ return (char*)""; }

return value(position());

}



const std::string Conteiner::value_string(const int index){

if(!isIndex(index)){ return (std::string)""; }

StringMap::iterator iter;

iter = conteiner->begin();
advance(iter, index);

return iter->second;

}


const int Conteiner::count(){ return conteiner->size(); }

const int Conteiner::size(){ return _size; }

void Conteiner::set_size(const int sz){ _size = sz; }


const int Conteiner::lenght(const int index){
int len = -1;
if(isIndex(index)){ len = utf8len(value(index)); }
return len; }


bool Conteiner::isExists(const char data){
StringMap::iterator iter;
std::string output;
char t[8];
sprintf(t, "%c", data);
output.append(t);
bool bool_return = false;

for(iter = conteiner->begin(); iter != conteiner->end(); ++iter){
if(iter->second == output){ bool_return = true; break; }
}

return bool_return; }

bool Conteiner::isExists(const char* data){
StringMap::iterator iter;
std::string output;
output.append(data);
bool bool_return = false;

for(iter = conteiner->begin(); iter != conteiner->end(); ++iter){
if(iter->second == output){ bool_return = true; break; }
}

return bool_return; }

bool Conteiner::isExists(const int data){
StringMap::iterator iter;
std::string output;
char t[64];
sprintf(t, "%d", data);
output.append(t);
bool bool_return = false;


for(iter = conteiner->begin(); iter != conteiner->end(); ++iter){
if(iter->second == output){ bool_return = true; break; }
}

return bool_return; }

bool Conteiner::isExists(const std::string data){
StringMap::iterator iter;
bool bool_return = false;

for(iter = conteiner->begin(); iter != conteiner->end(); ++iter){
if(iter->second == data){ bool_return = true; break; }
}

return bool_return; }


void Conteiner::insert(const char data, const int index){

if(!double_v){ if(isExists(data)){ return; } }

StringMap::iterator iter;

if(isIndex(index)){

char t[8];
sprintf(t, "%c", data);

conteiner->erase(index);
conteiner->insert(make_pair(index, ""));

iter = conteiner->begin();
advance(iter, index);

iter->second.reserve(_size);
iter->second.append(t);

}

else{ insert(data); }

}



void Conteiner::insert(const char* data, const int index){

if(!double_v){ if(isExists(data)){ return; } }

StringMap::iterator iter;

if(isIndex(index)){

conteiner->erase(index);
conteiner->insert(make_pair(index, ""));

iter = conteiner->begin();
advance(iter, index);

iter->second.reserve(_size);
iter->second.append(data);

}

else{ insert(data); }

}





void Conteiner::insert(const int data, const int index){

if(!double_v){ if(isExists(data)){ return; } }


StringMap::iterator iter;

if(isIndex(index)){

char t[64];
sprintf(t, "%d", data);

conteiner->erase(index);
conteiner->insert(make_pair(index, ""));

iter = conteiner->begin();
advance(iter, index);

iter->second.reserve(_size);
iter->second.append(t);

}

else{ insert(data); }

}




void Conteiner::insert(const std::string data, const int index){

if(!double_v){ if(isExists(data)){ return; } }


StringMap::iterator iter;

if(isIndex(index)){

conteiner->erase(index);
conteiner->insert(make_pair(index, ""));

iter = conteiner->begin();
advance(iter, index);

iter->second.reserve(_size);
iter->second.append(data.data());

}

else{ insert(data); }

}



void Conteiner::append(const char data, const int index){

if(!double_v) if(isExists(data)){ return; }

StringMap::iterator iter;

if(isIndex(index)){

char t[8];
sprintf(t, "%c", data);

iter = conteiner->begin();
advance(iter, index);
iter->second.append(t);

}

else{ insert(data); }

}





void Conteiner::append(const char* data, const int index){

if(!double_v) if(isExists(data)){ return; }

StringMap::iterator iter;

if(isIndex(index)){

iter = conteiner->begin();
advance(iter, index);
iter->second.append(data);

}

else{ insert(data); }

}



void Conteiner::append(const int data, const int index){

if(!double_v) if(isExists(data)){ return; }

StringMap::iterator iter;

if(isIndex(index)){

char t[64];
sprintf(t, "%d", data);

iter = conteiner->begin();
advance(iter, index);
iter->second.append(t);

}

else{ insert(data); }

}




void Conteiner::append(const std::string data, const int index){

if(!double_v) if(isExists(data)){ return; }

StringMap::iterator iter;

if(isIndex(index)){

iter = conteiner->begin();
advance(iter, index);
iter->second.append(data.data());

}

else{ insert(data); }

}



void Conteiner::set_position(const int index){ if(!isIndex(index)){ return; } _position = index; }

const int Conteiner::position(){ return _position; }


bool Conteiner::isStart(const int index){
if(index == Start()){ return true; }
return false; }

bool Conteiner::isEnd(const int index){
if(index == End()){ return true; }
return false; }


const int Conteiner::Start(){ return 0; }

const int Conteiner::End(){ return count()-1; }



bool Conteiner::ToEnd(const int index){

if(!isIndex(index) || count()==0){ return false; }
if((count()==2 && index > 0) || (count()==1) || (isEnd(index))){ return true; }

int t = index;

while(!isEnd(t)){ swap(t, (t+1)); ++t; }

return true; }


bool Conteiner::ToStart(const int index){

if(!isIndex(index) || count()==0){ return false; }
if(isStart(index)){ return true; }

int t = index;

while(!isStart(t)){ swap((t-1), t); --t; }

return true; }



bool Conteiner::swap(const int index_a, const int index_b){

if(!isIndex(index_a) || !isIndex(index_b)){ return false; }

bool g = false;

if(!double_v){ g = true; double_v = true; }

std::string a, b;

a = element(index_a);
b = element(index_b);

insert(a, index_b);
insert(b, index_a);

if(g){ double_v = false; }

return true; }



const int Conteiner::value_int(const int index){

if(!isIndex(index) || !isInt(index)){ return -1; }

int ret = -1;

FromString(value_string(index), ret);

return ret;

}


bool Conteiner::isInt(const int index){

if(!isIndex(index)){ return false; }

const char *str = value(index);
int len = utf8len(str);
int i = 0;

for(i; i < len; i++){

if(str[i] >= '0' && str[i] <= '9'){ continue; }
else{ return false; }

}

return true;

}




const int Conteiner::index(const char data){

StringMap::iterator iter;

char t[8];
sprintf(t, "%c", data);

std::string output;
output.append(t);

int index = -1;

for(iter = conteiner->begin(); iter != conteiner->end(); ++iter){
if(iter->second == output){ index = iter->first; break; } }

return index;

}





const int Conteiner::index(const char *data){

StringMap::iterator iter;
std::string output;
output.append(data);

int index = -1;

for(iter = conteiner->begin(); iter != conteiner->end(); ++iter){
if(iter->second == output){ index = iter->first; break; } }

return index;

}



const int Conteiner::index(const int data){

StringMap::iterator iter;

char t[64];
sprintf(t, "%d", data);

std::string output;
output.append(t);

int index = -1;

for(iter = conteiner->begin(); iter != conteiner->end(); ++iter){
if(iter->second == output){ index = iter->first; break; } }

return index;

}


const int Conteiner::index(const std::string data){

StringMap::iterator iter;

int index = -1;

for(iter = conteiner->begin(); iter != conteiner->end(); ++iter){
if(iter->second == data){ index = iter->first; break; } }

return index;

}



bool Conteiner::remove_index(const int index){

if(!isIndex(index)){ return false; }

if(!ToEnd(index)){ return false; }

conteiner->erase(End());

return true;

}


bool Conteiner::remove(const char data){

const int del_index = index(data);

if(del_index < 0){ return false; }

if(!ToEnd(del_index)){ return false; }

return remove_index(End());

}


bool Conteiner::remove(const char *data){

const int del_index = index(data);

if(del_index < 0){ return false; }

if(!ToEnd(del_index)){ return false; }

return remove_index(End());

}




bool Conteiner::remove(const int data){

const int del_index = index(data);

if(del_index < 0){ return false; }

if(!ToEnd(del_index)){ return false; }

return remove_index(End());

}


bool Conteiner::remove(const std::string data){

const int del_index = index(data);

if(del_index < 0){ return false; }

if(!ToEnd(del_index)){ return false; }

return remove_index(End());

}



void Conteiner::clear(){

conteiner->~multimap();

}

void Conteiner::clear(const int index){

if(!isIndex(index)){ return; }

StringMap::iterator iter;

iter = conteiner->begin();
advance(iter, index);
iter->second.clear();

}


bool Conteiner::isEmpty(const int index){

if(!isIndex(index)){ return true; }

return (value_string(index).empty());

}

bool Conteiner::isEmpty(){

if(count() == 0){ return true; }
else{ return false; }

}



const int Conteiner::num(const char data){

StringMap::iterator iter;

std::string output;
char t[8];
sprintf(t, "%c", data);
output.append(t);

int num_data = 0;

for(iter = conteiner->begin(); iter != conteiner->end(); ++iter){
if(iter->second == output){ num_data++; if(!double_v){ break; } }
}

return num_data;

}



const int Conteiner::num(const int data){

StringMap::iterator iter;

std::string output;
char t[64];
sprintf(t, "%d", data);
output.append(t);

int num_data = 0;

for(iter = conteiner->begin(); iter != conteiner->end(); ++iter){
if(iter->second == output){ num_data++; if(!double_v){ break; } }
}

return num_data;

}



const int Conteiner::num(const char *data){

StringMap::iterator iter;

std::string output;
output.append(data);

int num_data = 0;

for(iter = conteiner->begin(); iter != conteiner->end(); ++iter){
if(iter->second == output){ num_data++; if(!double_v){ break; } }
}

return num_data;

}



const int Conteiner::num(const std::string data){

StringMap::iterator iter;

int num_data = 0;


for(iter = conteiner->begin(); iter != conteiner->end(); ++iter){
if(iter->second == data){ num_data++; if(!double_v){ break; } }
}

return num_data;

}




void Conteiner::delete_doubles(){

StringMap *values = new StringMap;
StringMap::iterator iter_local;
StringMap::iterator iter;
int e = 0;

for(iter = conteiner->begin(); iter != conteiner->end(); ++iter){
if(num(iter->second) > 1){ values->insert(make_pair(e, iter->second)); e++;
 }
}

if(e > 0){
for(iter_local = values->begin(); iter_local != values->end(); ++iter_local){
while(1){ if(num(iter_local->second) > 1){ remove(iter_local->second); } else{ break; } }
 }
}

delete values;

}


bool Conteiner::double_values(){ return double_v; }

void Conteiner::double_values(bool d){

if(!d){ delete_doubles(); }
double_v = d;

}




const char* Conteiner::next(){

if((position()+1) == count()){ return (char*)""; }
set_position(position()+1);
return value(position());

}

const char* Conteiner::prev(){

if((position()-1) < Start()){ return (char*)""; }
set_position(position()-1);
return value(position());

}

const std::string Conteiner::next_string(){

if((position()+1) == count()){ return (std::string)""; }
set_position(position()+1);
return value_string(position());

}

const std::string Conteiner::prev_string(){

if((position()-1) < Start()){ return (std::string)""; }
set_position(position()-1);
return value_string(position());

}

#endif

//
// End of  "$Id: Conteiner.cxx The Dec 18 2006 Dmitry Perov  $".
//
